####################################################
# Blah Software Code      |    Software Version: 2 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/Attach.lng");

sub Upload {
	if($uallow == 0) { &error($atext[1]); }
	if($uallow == 2 && $username eq 'Guest') { &error($atext[55]); }
	if($uallow == 3 && $settings[4] ne 'Administrator') { &error($atext[56]); }
	$fname = lc($FORM{'ulfile'});
	$fname =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
	$fname =~ s/^.*(\\|\/)//;
	$fname =~ s/ /_/g;
	$fname =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\)\(\]\[\;{}!`=-]//g;
	if($fname eq '.htaccess') { &error($atext[5]); }

	$uploadz = new CGI;
	$file = $uploadz->param("ulfile");
	$tmpfile = $uploadz->tmpFileName($file);

	if($allowedext ne '') {
		$fnchk = $fname;
		$fnchk =~ s/(.+?)[(.)]/$2/gsi;

		@allowed = split(",",$allowedext);
		foreach(@allowed) {
			if($fnchk eq lc("$_")) { $okay = 1; last; }
		}
		foreach(@allowed) { $aup .= "$_, "; }
		$aup =~ s/, \Z//i;
		if($okay != 1) { &error("$atext[2] $aup"); }
	}

	$savedfile = "$uploaddir/$fname";
	if(-e "$savedfile") { &error($atext[3]); }

	fopen(OUTFILE, ">$savedfile");
	if($ntsys) { binmode(OUTFILE); }
	while($bytesread = read($file,$buffers,1024)) { print OUTFILE $buffers; }
	fclose(OUTFILE);

	$savedsize = -s ($savedfile);
	if($savedsize == 0) { unlink($savedfile); &error($atext[4]); }
	$savedsize = sprintf("%.2f",($savedsize/1024/1024));
	if($maxsize > 0) {
		if($maxsize < $savedsize) {
			unlink("$savedfile");
			$over = $savedsize-$maxsize;
			&error($atext[5]);
		}
	}
	fopen(FILE,">$prefs/Hits/$fname.txt");
	print FILE "0";
	fclose(FILE);
	$atturl = "$fname";
	my $tttime = time;
	if($username eq 'Guest') { $temp1 = $ENV{'REMOTE_ADDR'}; } else { $temp1 = $username; }
	fopen(FILE,"+>>$prefs/Attachments.txt");
	print FILE "$atturl|$savedsize|$URL{'b'}|$URL{'m'}|$tttime|$temp1\n";
	fclose(FILE);
	if($uextlog) { ++$ExtLog[4]; }
	if($message =~ /\[upload\]/) { $message =~ s~\[upload\]~$uploadurl/$atturl~gsi; }

	unlink("$root/Blah.pl.core"); # Is this the source of the .core problem?
}

sub Download {
	if(-e("$uploaddir/$URL{'f'}") == 0) { &error($atext[6]); }
	fopen(ADD,"+<$prefs/Hits/$URL{'f'}.txt");
	$nump = <ADD> || 0;
	seek(ADD,0,0);
	truncate(ADD,0);
	print ADD $nump+1,"\n";
	fclose(ADD);

	if($uextlog) { ++$ExtLog[5]; &ExtClose; }

	$title = $gtxt{'14'};
	&header;
	print <<"EOT";
<meta http-equiv="refresh" content="1;url=$uploadurl/$URL{'f'}">
<table bgcolor="$color{'border'}" cellspacing="1" cellpadding="4" width="500" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/open_thread.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">$atext[7] <a href="$uploadurl/$URL{'f'}">$atext[8]</a>.</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}
1;
