####################################################
# Blah Software Code      |    Software Version: 2 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2002 e-blah!                  #
# All Rights Reserved                              #
####################################################

$themever = "1.2";
$themesupp = "1";

require("$language/Themes.lng");

sub ThemeManager {
	$url = "$scripturl,v=admin,a=themesman,p=browse";
	if($URL{'p'} eq 'delete') {
		$URL{'t'} =~ s/\+/ /gsi;
		unlink("$theme/$URL{'t'}");
		&redirect;
	} elsif($URL{'p'} eq 'save') {
		$URL{'t'} =~ s/.v1\Z//gsi;
		$URL{'t'} =~ s/\+/ /gsi;
		$FORM{'theme'} = Format($FORM{'theme'});
		if($URL{'t'} ne '' && $FORM{'theme'} ne '') {
			unlink("$theme/$URL{'t'}.v1");
		} else {
			if(-e("$theme/$FORM{'theme'}.v1") && $URL{'t'} eq '') { &error("$FORM{'theme'}.v1 already exists, please rename this theme and try again."); }
		}
		$URL{'t'} = $FORM{'theme'};
		if($URL{'t'} eq '') { &error("The theme is invalid."); }
		$URL{'t'} =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\]\[\;{}!`=-]//g;
		if($FORM{'template'} eq '' || $FORM{'titlebg'} eq '' || $FORM{'catbg'} eq '' || $FORM{'win'} eq '' || $FORM{'win2'} eq '' || $FORM{'border'} eq '') { &error("All fields are required."); }
		$buffer = <<"EOT";
\$template = qq~$FORM{'template'}~;
\$color{'titlebg'} = qq~$FORM{'titlebg'}~;
\$color{'catbg'} = qq~$FORM{'catbg'}~;
\$color{'win'} = qq~$FORM{'win'}~;
\$color{'win2'} = qq~$FORM{'win2'}~;
\$color{'border'} = qq~$FORM{'border'}~;
\$color{'text'} = qq~$FORM{'text'}~;
\$color{'link'} = qq~$FORM{'link'}~;
\$color{'background'} = qq~$FORM{'background'}~;
1;
EOT
		$URL{'t'} =~ s/[#%+,\\\/:?"<>'|@^\$\&~'\)\(\]\[\;{}!`=-]//g;
		$URL{'t'} =~ s/ /_/gi;
		fopen(FILE,">$theme/$URL{'t'}.v1");
		print FILE "$buffer";
		fclose(FILE);
		&redirect;
	} elsif($URL{'p'} eq 'stemp') {
		$URL{'t'} =~ s/\+/ /gsi;
		if(-e "$theme/$URL{'t'}") { require("$theme/$URL{'t'}"); }
			else { &error("The theme you chose is not valid."); }
		$opentemplate = $template || "$root/template.pl";
		fopen(FILE,"+>$opentemplate");
		print FILE $FORM{'template'};
		fclose(FILE);

		if(!$smiliestemplate) { $smiliestemplate = "$prefs/Smilies.pl"; }
		fopen(FILE,"+>$smiliestemplate");
		print FILE $FORM{'stemplate'};
		fclose(FILE);
		&redirect;
	}
	$span = 1;
	if($URL{'p'} eq 'template') { $span = 2; }
	$title = "Theme Manager";
	&header;
	print <<"EOT";
<script language="javascript">
<!-- //
function clear(name,url) {
 if(window.confirm("Deleting this theme is unrecoverable.\\nDo you really want to delete this theme: \\""+(name)+"\\"?")) { location = url; }
}
// -->
</script>
$response<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" width="600" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan="$span"><font size="2"><b> $title</b></font></td>
 </tr>
EOT
	if($URL{'p'} eq 'browse' || $URL{'p'} eq '') {
		opendir(DIR,"$theme/");
		@themes = readdir(DIR);
		closedir(DIR);
		foreach(@themes) {
			$themename = $_;
			$themename =~ s/ /\+/gsi;
			if($_ =~ m/(.*)(.v1)/) { $themelist .= qq~<b> $1</b><br>  - <a href="javascript:clear('$1','$scripturl,v=admin,a=themesman,p=delete,t=$themename')">Delete Theme</a><br>  - <a href="$scripturl,v=admin,a=themesman,p=modify,t=$themename">Modify Theme</a><br>  - <a href="$scripturl,v=admin,a=themesman,p=template,t=$themename">Modify Theme Template</a><br>~; }
		}
		print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> Browsing Themes</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="1">The following is a list of themes currently installed on this board. This board accepts <b>Version 1</b> themes only, <a href="$scripturl,v=admin,a=version">click here to update</a>. Deleting Themes does not remove the Template to that theme.</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}"><font size="1">$themelist</font></td>
 </tr>
EOT
	} elsif($URL{'p'} eq 'modify') {
		if($URL{'t'}) {
			$themename = $URL{'t'};
			$themename =~ s/\+/ /gsi;
			$themename =~ s/.v1\Z//gsi;
			$URL{'t'} =~ s/\+/ /gsi;
			if(-e "$theme/$URL{'t'}") { StopThemes("$theme/$URL{'t'}"); }
		} else { $template = "$root/template.pl"; }
		if(!$smiliestemplate) { $smiliestemplate = "$prefs/Smilies.pl"; }
		$what = $URL{'t'} ? "Modify Theme" : "Create Theme";
		$URL{'t'} =~ s/ /\+/gsi;
		print <<"EOT";
 <tr>
  <td bgcolor="$color{'catbg'}"><font size="2"><b> $what</b></font></td>
 </tr><tr><form action="$scripturl,v=admin,a=themesman,p=save,t=$URL{'t'}" method="post">
  <td bgcolor="$color{'win2'}">
   <table cellpadding="3" cellspacing="0" width="100%">
    <tr>
     <td width="35%" align="right"><font size="2"><b>Theme Name:</b></font></td>
     <td width="65%"><input type="text" name="theme" value="$themename"></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Location to Template:</b></font></td>
     <td width="65%"><input type="text" name="template" value="$template"></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Smileys Template:</b></font></td>
     <td width="65%"><input type="text" name="smileys" value="$smiliestemplate"></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Title Color:</b></font></td>
     <td width="65%"><input type="text" name="titlebg" value='$titlebg'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Category Color:</b></font></td>
     <td width="65%"><input type="text" name="catbg" value='$catbg'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Window Color:</b></font></td>
     <td width="65%"><input type="text" name="win" value='$win'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Window 2 Color:</b></font></td>
     <td width="65%"><input type="text" name="win2" value='$win2'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Border Color:</b></font></td>
     <td width="65%"><input type="text" name="border" value='$border'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Text Color:</b></font></td>
     <td width="65%"><input type="text" name="text" value='$text'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Link Color:</b></font></td>
     <td width="65%"><input type="text" name="link" value='$link'></td>
    </tr><tr>
     <td width="35%" align="right"><font size="2"><b>Background Color:</b></font></td>
     <td width="65%"><input type="text" name="background" value='$background'></td>
    </tr><tr>
     <td colspan="2" align="center"><input type="submit" value=" Save " name="submit"></td>
    </form></tr>
   </table>
  </td>
 </tr>
EOT
	} elsif($URL{'p'} eq 'template') {
		$themename = $URL{'t'};
		$themename =~ s/\+/ /gsi;
		$themename =~ s/.v1\Z//gsi;
		$URL{'t'} =~ s/\+/ /gsi;
		if(-e "$theme/$URL{'t'}") { &StopThemes("$theme/$URL{'t'}"); }
			else { print "</table><br>"; &error("The theme you chose is not valid."); }

		$opentemplate = $template || "$root/template.html";

		$what = "Modify Template";
		$URL{'t'} =~ s/ /\+/gsi;
		fopen(FILE,"$opentemplate");
		@stemp = <FILE>;
		fclose(FILE);
		chomp @stemp;
		foreach (@stemp) { $templatea .= "$_\n"; }

		if(!$smiliestemplate) { $smiliestemplate = "$prefs/Smilies.pl"; }
		fopen(FILE,"$smiliestemplate");
		@stemp = <FILE>;
		fclose(FILE);
		chomp @stemp;
		foreach (@stemp) { $stemplatea .= "$_\n"; }

		print <<"EOT";
 <tr><form action="$scripturl,v=admin,a=themesman,p=stemp,t=$URL{'t'}" method="post" name="post">
  <td bgcolor="$color{'titlebg'}" width="50%"><font size="2"><b><img src="$images/xx.gif"> Main Template</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center"><textarea rows="10" cols="90" name="template">$templatea</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'catbg'}" colspan="2"><font size="2"><b><img src="$images/smiley.gif"> Smiley Template</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center"><textarea rows="10" cols="90" name="stemplate">$stemplatea</textarea></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}" align="center" colspan="2"><input type="submit" name="submit" value="Save"></td>
 </form></tr>
EOT
	}
	print <<"EOT";
 <tr>
  <td bgcolor="$color{'win'}" colspan="$span"><font size="1"><b>- <a href="$scripturl,v=admin,a=themesman,p=browse">Browse Currently Installed Themes</a><br>- <a href="$scripturl,v=admin,a=themesman,p=modify">Create New Theme</a></b></font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub StopThemes {
	($whatfile) = $_[0];
	# This will copy your theme, replace colors, then restore your theme.
	$tt = $color{'titlebg'};
	$tc = $color{'catbg'};
	$tw = $color{'win'};
	$tw2 = $color{'win2'};
	$tb = $color{'border'};
	$bg = $color{'background'};
	$lnk = $color{'link'};
	$txt = $color{'text'};
	require("$whatfile");
	$titlebg = $color{'titlebg'};
	$catbg = $color{'catbg'};
	$win = $color{'win'};
	$win2 = $color{'win2'};
	$border = $color{'border'};
	$text = $color{'text'};
	$link = $color{'link'};
	$background = $color{'background'};
	# Restore Colors ...
	$color{'titlebg'} = $tt;
	$color{'catbg'} = $tc;
	$color{'win'} = $tw;
	$color{'win2'} = $tw2;
	$color{'border'} = $tb;
	$color{'text'} = $txt;
	$color{'background'} = $bg;
	$color{'link'} = $lnk;
	# Finaly, Theme code done ...
}
1;
